'Blitz Max Community Framework competition II entry
'By: Nathan Shirley
'Entry Subject: Physics (fluid)
'Entry Name: Flood ( a remake of Polluted Planet which was abandoned at an early stage.
SuperStrict	'yes its super strict.. now get to buisness

AppTitle = "Flood"	'title at the top

Graphics 1024,768,0,30		'30 fps because bmax threaded builds slow down the threaded version sooo much its unbearable... I think its the Threaded GC but anyway: on with the program! (no pun intended)

Include "Verlet Max/Verlet Max.bmx"	'include verlet max (sorry I dont have it in module form yet! :( I need to figure out how to do that soon)
InitVerletMax()		'Lets tell the physics engine to do all of the boring setup stuff right now but it cant do everything
ConstraintIterations = 13		'lets crank up the accuracy here! the more iterations the more accurate constrained objects are but the slower it will run.  since almost everything in our game is fluid except the player we could use some accuracy
gravityy = .05
Global cnt:Int = 10
HideMouse()
'GLOBALS
Global loadingimage:TImage = LoadImage("title.png")
DrawImage loadingimage,512,350
Flip
Delay 500

Local loadtimer:Float =100
SetBlend alphablend

Global enemysetshoot:Int = False
''''''''''''''''''''''''''''''''''''''''''
'Normal physics object IDs
Global ID_Player:Int = 1	'ids for everything
Global ID_Fluid:Int = 2
'''''''''''''''''''''''''''''''''''''''''''


'''''''''''''''''''''''''''''''''''''''''''
'These are fluid IDs for the fluid engine
Global ID_Lava:Int = 3
Global ID_Water:Int = 4
Global ID_Rock:Int = 5
Global ID_Wall:Int = 6
Global ID_killer:Int = 7
'''''''''''''''''''''''''''''''''''''''''''


Global Levelwidth:Int
Global LevelHeight:Int
Global levelx:Int
Global levely:Int
Global leveltotwidth:Int
Global leveltotheight:Int
Global PlayerStartx:Int
Global PlayerStarty:Int
Global Exitx:Int
Global Exity:Int

Global steamsnd:TSound = LoadSound("steam.wav")
Global collect:TSound = LoadSound("collect.wav")
Global music:TSound = LoadSound("music.ogg",Sound_Loop)
Global fire:TSound = LoadSound("fire.ogg",Sound_Loop)
Global bump:TSound = LoadSound("wallhit.ogg")
Global firechannel:TChannel = AllocChannel()
Global wall:TImage = LoadImage("wall.png")

firechannel.setvolume(0)
PlaySound fire,firechannel
PlaySound music

'lets make a player
Global plx:Float	'x and y
Global ply:Float
Global pldx:Float	'velocity x and y
Global pldy:Float
Global plang:Float	'angle of rotation
Global plwater:Int = 0	'how much water do you have
Global plpoints:Float	'how many points do you have
Global plimg:TImage = LoadImage("ship.png")
Global plheat:Float = 0
Global plhealth:Float = 100
Global pltanksize:Float = 300
Global pldie:Int = False
Global pldie2:Int = False	'triggered at the end of the death scene
Global plwin:Int = False
Global plwin2:Int = False	'triggered at the end of the win scene
Global beginlavacount:Int
Global endlavacount:Int

Global camerashakeflag:Int = 0

'END GLOBALS

'ID STUFF
SetIDSelfCollide(ID_Fluid)
'END ID STUFF

'hmm now what are the elements of a game... oh yeah it needs a player doesnt it!
'Local pl1:player = player.Create(100,100,15)	'x,y and radius

Local ext:Int = 0		'exit variable for the main loop

Global level:Int = -1

Global state:Int = 0

Incbin "blob2.png"
Global water:TImage = LoadImage("incbin::blob2.png")


'SetClsColor 255,255,255

Local timer:Int = 0

flproperty.Create(ID_water,ID_lava,6.5,6,.03,.3)
flproperty.Create(ID_water,ID_rock,5.5,5,.02,.3)

Local rock:verlet = verlet.Create(-100,-100,7,1,ID_fluid,1,0,0)
rock.setfluidproperties(True,4.4,4,.5,.45,ID_Rock)
rock.image = water
rock.color(50,50,50)
rock.alpha(.5)
rock.blendmode = lightblend
rock.remove

Local killer:verlet = verlet.Create(0,0,0,.000001,ID_killer,1)
killer.image = water
killer.blendmode = lightblend
killer.remove

flreaction.Create(ID_water,ID_lava,False,False,killer:verlet,rock:verlet)

setup()
grid.activate(14)

Global diealpha# = 0
Global winalpha# = 0

Local spcflag:Int = 0
'sandbox screen loop
While loadtimer > 0
	Cls
	updatephysics()
	
	SetAlpha 1
	DrawImage loadingimage,512,350
	updatephysics()
	drawverlets()
	DrawText "By: Nathan Shirley",440,450
	DrawText "Music from: www.soundjay.com",400,470
	DrawText "Press the space bar to continue.",390,490
	
	For Local i:Int = 0 To 1
		makewater(MouseX()+Rnd(5),MouseY()+Rnd(5))
	Next
	If verlcount > 2000 Then
		Local v:verlet = verletarray[Rnd(0,1999)]
		v.remove
		Local vv:verlet = verletarray[Rnd(0,1999)]
		vv.remove
	EndIf
	If KeyHit(key_space) Then spcflag = True
	If spcflag Then loadtimer:-1
	SetAlpha (-(loadtimer/100.0)+1)
	SetColor 0,0,0
	DrawRect 0,0,1025,769
	SetColor 255,255,255
	Flip
Wend
'end sandbox loop
enemysetshoot:Int = True

Global fadein:Float = 1
Global fadenow:Int = 1

Global fadewin:Float = 1
Global fadewinnow:Int = 0

Global fadedie:Float = 1
Global fadedienow:Int = 0

setup()	'lets set up some stuff

Grid.Activate(16)		'We want a FAST physics engine right? so lets do some optimizing and make a collision grid.  14 is double the maximum radius of any particles in the simulation to prevent bugs so the biggest particle we will use will have a radius of 14/2 = 9... edit: just kidding I meant to say 7
Local tim:Int

'main loop
While Not ext	'so keep the game goin till someone does somethin to stop it
Cls	'clear the screen
	SetColor 255,255,255
	'DrawText MilliSecs()-tim,1,1
	tim = MilliSecs()
	timer:+1
	Local v:verlet
	Local vcnt:Int = verlcount-1
	plhealth :+.04
	
	If pldie2 Then
		plpoints = 0
		pldie2 = False
		pldie = False
		plhealth = 100
		plheat = 0
		plwater = 0
		level :-1
		setup()
		fadedienow = 1
	EndIf
	If plwin2 Then
		countlava()
		plwin2 = False
		plwin = False
		plhealth = 100
		plheat = 0
		plwater = 0
		setup()
		fadewinnow = 1
	EndIf

	checkportal()
	
	
	
	If AppTerminate() Then ext = 3
	If KeyHit(key_escape) Then ext = 2
	
	wemitter.update()
	updatephysics()
	
	positionphysicscam(-plx+512,-ply+384)
	If physicsoffsetx > -levelx Then physicsoffsetx = -levelx
	If physicsoffsetx < (-levelx-levelwidth)+1024 Then physicsoffsetx = (-levelx-levelwidth)+1024
	If physicsoffsety > -levely Then physicsoffsety = -levely
	If physicsoffsety < (-levely-levelheight)+768 Then physicsoffsety = (-levely-levelheight)+768
	
	
	Local vct:Int
	Local v1:verlet
	For vct = 0 To verlcount-1
		v1:verlet = verletarray[vct]
		If v1.id = ID_killer Then
			v1.remove
			For Local i:Int = 0 To 4
				steam.Create(v1.x,v1.y,Rnd(-.3,.3),Rnd(-2,-.5),Rnd(0,.2))
			Next
			PlaySound(steamsnd)
			plpoints :+1
		EndIf
		If v1.y > levely + levelheight+8 And v1.fluid = True Then
			v1.remove()
		EndIf
	Next
	camerashake()
	coin.update
	updateplayer()
	
	drawverlets()
	enemy.update()
	steam.update()
	
	renderhud()
	
	SetAlpha 1
	SetColor 255,255,255
	DrawText "Points: "+Int(plpoints),1,1
	
	
	If pldie Then
		diealpha :+.01
	EndIf
	If plwin Then
		winalpha :+.01
	EndIf
	
	If pldie And plwin Then
		plwin = False
	EndIf
	SetColor 255,0,0
	SetAlpha diealpha
	DrawRect 0,0,1025,769
	SetAlpha winalpha
	SetColor 255,255,255
	DrawRect 0,0,1025,769	
	
	If winalpha > 1 Then
		winalpha = 0
		plwin2 = True
		plwin = False
	EndIf
	
	If diealpha > 1 Then
		diealpha = 0
		pldie2 = True
		pldie = False
	EndIf
	
	If fadenow Then
		fadein:- .01
		SetAlpha fadein
		SetColor 0,0,0
			DrawRect 0,0,1025,769
		SetAlpha 1
		SetColor 255,255,255
		If fadein < 0 Then
			fadein = 1
			fadenow = 0
		EndIf
	EndIf
	
	If fadedienow Then
		fadedie:- .01
		SetAlpha fadedie
		SetColor 255,0,0
			DrawRect 0,0,1025,769
		SetAlpha 1
		SetColor 255,255,255
		If fadedie < 0 Then
			fadedie = 1
			fadedienow = 0
		EndIf
	EndIf

	If fadewinnow Then
		fadewin:- .01
		SetAlpha fadewin
			DrawRect 0,0,1025,769
		SetAlpha 1
		If fadewin < 0 Then
			fadewin = 1
			fadewinnow = 0
		EndIf
	EndIf
	
	'update exit portal
	
	For Local i:Int = 0 To 4
		steam.Create(exitx,exity,Rnd(-2,2.0),Rnd(-2,2.0),Rnd(0,.2),Rnd(50),Rnd(100,255),Rnd(100))
	Next
	
	''''''''''''
	
Flip	'flip the buffers
Wend	'end the main loop


Select ext	'so why did the main loop exit? lets find out
Case 1
	'you died/lost
Case 2
	'you quit
Case 3
	'you clicked the x button :(
	End	'bye bye
End Select

Function countlava()
Local v:verlet
Local c:Int
endlavacount = 0
For c = 0 To verlcount-1
	v:verlet = verletarray:verlet[c]
	If v.flid = ID_lava Then endlavacount :+1
Next
End Function

Function setup()		'uh this sets up the first level of the game
	clearlevel()	'delete everything in first level
	GCCollect()	'sometimes the gc doesnt collect fast enough and there are weird results...
	level :+ 1		'incriment level by 1
	beginlavacount = 0
	loadlevel(level)	'load the new level
	If level = 6 Then
		Notify("Congragulations, you beat FLOOD with "+Int(plpoints)+" points! Stay tuned, more fun levels to come!")
		End
	EndIf
End Function


Function checkportal()
	Local dx:Float = exitx-plx
	Local dy:Float = exity-ply
	Local dist:Float = dx*dx + dy*dy
	
	If dist < 1600 Then
		plwin = True
	EndIf
End Function


Function camerashake()
	If camerashakeflag > 0 Then
		movephysicscam(Rnd(-7,7),Rnd(-7,7))
		camerashakeflag :-1
	EndIf
End Function

Function updateplayer()
	If plheat > 1 Then
		For Local i:Int = 0 To (plheat-1)*2+4
		steam.Create(plx,ply,Rnd(-2,2.0),Rnd(-2,2.0),Rnd(0,.2),100,Rnd(0,100),0)
		Next
		firechannel.setvolume((plheat-1)*5+1)
	Else
		firechannel.setvolume(1)
	EndIf
	
	SetRotation plang
	SetScale 2,2
	SetAlpha .4
	SetBlend lightblend
		DrawImage water,plx+physicsoffsetx,ply+physicsoffsety
	SetBlend alphablend
	SetAlpha 1
	SetScale .5,.5
	DrawImage plimg,plx+physicsoffsetx,ply+physicsoffsety
	SetScale 1,1
	SetRotation 0
	
	Local x:Float = MouseX()-512
	If x > 28 Then x =28
	If x < -28 Then x = -28
	x :/2
	plang :+x
	MoveMouse(512,384)
	If MouseDown(2) Then	'thrust key
		pldx :+ Cos(plang-90)/2
		pldy :+ Sin(plang-90)/2
		steam.Create(plx,ply,Rnd(-.3,.3)-Cos(plang-90)*.001,Rnd(-2,-.5)-Sin(plang-90)*.001,Rnd(0,.2),200,200,200)
		'your heat meter goes up when you use your engine
		plheat :+.005
	EndIf
	plx :+pldx
	ply :+pldy
	pldx :*.94
	pldy :*.94
	
	If plx-20 < levelx Then
		pldx = -pldx
		plx = levelx+20
	EndIf
	If plx+20 > levelx+levelwidth Then
		pldx = -pldx
		plx = levelx+levelwidth-20
	EndIf
	If ply-20 < levely Then
		pldy = -pldy
		ply = levely+20
	EndIf
	
	If ply+20 > levely+levelheight Then
		pldy = -pldy
		ply = levely+levelheight-20
	EndIf
	
	'now lets have it suck up water
	
		Local v:verlet
		Local c:Int
		For c = 0 To verlcount-1
			v:verlet = verletarray:verlet[c]
			If v.fluid Then
				If v.flid = ID_water Then
					If plwater < pltanksize Then
						Local dx:Float = plx-v.x
						Local dy:Float = ply-v.y
						Local dist:Float = dx*dx+dy*dy
						If dist < 900 Then	'900 = 30^2
							dist = Sqr(dist)
							dist = dist * 2
							dx = dx / dist
							dy = dy / dist
							v.addvelocity(dx,dy)
							If dist < 10 Then
								v.remove
								plwater:+1
							EndIf
							If plheat > 0 Then
								plheat = plheat - .05
								If plheat < 0 Then plheat = 0
								steam.Create(plx,ply,Rnd(-.8,.8),Rnd(-4,-2.1),Rnd(0,.2),Rnd(40,50),Rnd(40,50),Rnd(50,70))
								PlaySound steamsnd
							EndIf
						EndIf
					Else
						Local dx:Float = plx-v.x
						Local dy:Float = ply-v.y
						Local dist:Float = dx*dx+dy*dy
						If dist < 400 Then	'900 = 30^2
							dist = Sqr(dist)
							dx = dx / dist
							dy = dy / dist
							dist = 21-dist
							If dist > 2 Then dist = 2
							v.x:- dx*dist*.99
							v.y:- dy*dist*.99
							pldx:+ dx*dist*.01
							pldy:+ dy*dist*.01
							If plheat > 0 Then
								plheat = plheat - .05
								If plheat < 0 Then plheat = 0
								steam.Create(plx,ply,Rnd(-.8,.8),Rnd(-4,-2.1),Rnd(0,.2),Rnd(40,50),Rnd(40,50),Rnd(50,70))
								PlaySound steamsnd
							EndIf
							
						EndIf
					EndIf
				ElseIf v.flid = id_lava Then
					Local dx:Float = plx-v.x
					Local dy:Float = ply-v.y
					Local dist:Float = dx*dx+dy*dy
					If dist < 400 Then	'400 = 20^2
						dist = Sqr(dist)
						dx = dx / dist
						dy = dy / dist
						dist = 21-dist
						v.x:- dx*dist*.98
						v.y:- dy*dist*.98
						pldx:+ dx*dist*.02
						pldy:+ dy*dist*.02
						steam.Create(plx,ply,Rnd(-.3,.3),Rnd(-2,-.5),Rnd(0,.2),255,Rnd(0,100),0)
						plheat :+ .2
					EndIf
				ElseIf v.flid = id_rock Then
					Local dx:Float = plx-v.x
					Local dy:Float = ply-v.y
					Local dist:Float = dx*dx+dy*dy
					If dist < 400 Then	'400 = 20^2
						dist =Sqr(dist)
						dx = dx / dist
						dy = dy / dist
						dist = 21-dist
						v.x :- dx*dist * .91
						v.y :- dy*dist * .91
						pldx :+dx*dist*.09
						pldy :+dy*dist*.09
						plheat :+ .002
					EndIf
				EndIf
			ElseIf v.ID = ID_wall
				Local dx:Float = plx-v.x
				Local dy:Float = ply-v.y
				Local dist:Float = dx*dx+dy*dy
				If dist < 400 Then	'400 = 20^2
					dist =Sqr(dist)
					If dist < 12 Then
						For Local i:Int = 0 To 5
							camerashakeflag = 10
							steam.Create(v.x,v.y,Rnd(-.3,.3),Rnd(-2,-.5),Rnd(0,.2))
							PlaySound(bump)
							plhealth :-3
						Next
					EndIf
					dx = dx / dist
					dy = dy / dist
					dist = 21-dist
					pldx :+dx*dist*.2
					pldy :+dy*dist*.2
					
				EndIf
				
			EndIf
		Next
		
	If MouseDown(1) And plwater > 0 Then
		plwater :-1
		Local v:verlet = makewater(plx+Cos(plang-90)*30+pldx+Rnd(-10,10),ply+Sin(plang-90)*30+pldy+Rnd(-10,10))
		v.addvelocity(Cos(plang-90)*5+pldx*.2,Sin(plang-90)*5+pldy*.2)
	EndIf
End Function


Function clearlevel()	'delete everything but the player and start over
	
	Local v:verlet
	Local vcnt:Int = verlcount-1
	For Local cnt:Int = 0 To vcnt	'loop through verlets
		v:verlet = verletarray:verlet[0]	'my way of looping through extra fast compared to a list
		v.remove()	'remove them! if they are fluid and exist
	Next
	updatephysics()
	enemy.clear
	coin.clear
	wemitter.clear
	steam.clear
End Function

Function loadlevel:Int(lvl:Int)	'lets load us some levels
	Local file:TStream = ReadFile("levels/level"+lvl+".lvl")	'open the file
	
	If file = Null Then Return False	'check to see if it worked
		playerstartx = Int(ReadLine(file))
		playerstarty = Int(ReadLine(file))
		plx = playerstartx
		ply = playerstarty
		exitx = Int(ReadLine(file))
		exity = Int(ReadLine(file))
		leveltotwidth = Int(ReadLine(file))
		leveltotheight = Int(ReadLine(file))
		levelx = Int(ReadLine(file))
		levely = Int(ReadLine(file))
		levelwidth = Int(ReadLine(file))
		levelheight = Int(ReadLine(file))
		
		Local t$ = ReadLine(file)
		
		While t$ >< "end"
			Local x:Int = Int(ReadLine(file))
			Local y:Int = Int(ReadLine(file))
			Local v:verlet = verlet.Create(x,y,10,100,ID_wall,False)
			v.image = wall
			t$ = ReadLine(file)
		Wend
		
		t$ = ReadLine(file)
		While t$ >< "end"
			Local x:Int = Int(ReadLine(file))
			Local y:Int = Int(ReadLine(file))
			Local w:Int = Int(ReadLine(file))
			Local h:Int = Int(ReadLine(file))
			Local cnt:Int = Int(ReadLine(file))
			Local ppf:Int = Int(ReadLine(file))
			t$ = ReadLine(file)
			wemitter.Create(x,y,w,h,cnt,ppf)
			
		Wend
		
		t$ = ReadLine(file)
		While t$ <> "end"
			Local x:Int = Int(ReadLine(file))
			Local y:Int = Int(ReadLine(file))
			Local radius:Int = Int(ReadLine(file))
			Local particles:Int = Int(ReadLine(file))
			enemy.Create(x,y,radius,particles)
			beginlavacount :+particles
			t$ = ReadLine(file)
		Wend
		
		t$ = ReadLine(file)
		While t$ <> "end"
			Local x:Int = Int(ReadLine(file))
			Local y:Int = Int(ReadLine(file))
			coin.Create(x,y)
			t$ = ReadLine(file)
		Wend
		
		setphysicsbounds(0,0,leveltotwidth,leveltotheight)
		grid.activate(16)	
	CloseFile file	'close the file
	Return True		'and return
End Function

Type wemitter
	Global waterlist:TList = New TList
	Field x:Int
	Field y:Int
	Field width:Int
	Field height:Int
	Field count:Int
	Field ppf:Int
	
	Function clear()
		For Local w:wemitter = EachIn waterlist
			waterlist.remove(w:wemitter)
		Next
	End Function
	
	Function Create:wemitter(x:Int,y:Int,wi:Int,h:Int,cnt:Int,ppf:Int)
		Local w:wemitter = New wemitter
		w.x = x
		w.y = y
		w.width = wi
		w.height = h
		w.count = cnt
		w.ppf = ppf
		waterlist.addlast(w:wemitter)
		Return w:wemitter
	End Function
	
	Function update()
		For Local w:wemitter = EachIn waterlist
			If w.count > 0 Or w.count < 0 Then
				Local pe:Int = 0
				While (w.count > 0 Or w.count < 0) And pe < w.ppf
					pe:+1
					Local v:verlet = verlet.Create(w.x+Rnd(w.width),w.y+Rnd(w.width),7,.4,ID_Fluid,1)
					v.setfluidproperties(True,7.7,5,.01,.1,ID_Water)
					v.image = water
					v.alpha(.5)
					v.color(30,40,255)
					v.blendmode = lightblend
					w.count :-1
				Wend
			EndIf
		Next
	End Function
End Type


Type steam
	Global steamlist:TList = New TList
	
	Field x:Float
	Field y:Float
	Field dx:Float
	Field dy:Float
	Field alpha:Float
	Field alphswitchflag:Int
	Field r:Int
	Field g:Int
	Field b:Int
	
	Function clear()
		For Local s:steam = EachIn steamlist
			steamlist.remove(s:steam)
		Next
	End Function
		
	Function Create:steam(x:Float,y:Float,dx:Float,dy:Float,alpha:Float,r:Int= 255,g:Int = 255,b:Int = 255)
		Local s:steam = New steam
		s.x = x
		s.y = y
		s.dx = dx
		s.dy = dy
		s.alpha = alpha
		s.r = r
		s.g = g
		s.b = b
		steamlist.addlast(s:steam)
		Return s:steam
	End Function
	
	Function update()
		SetAlpha .4
		SetScale 2,2
		SetBlend lightblend
		For Local s:steam = EachIn steamlist
			SetAlpha s.alpha/8
			SetColor s.r,s.g,s.b
			DrawImage2 water,s.x+physicsoffsetx,s.y+physicsoffsety
			SetColor 255,255,255
			s.x :+ s.dx
			s.y :+ s.dy
			If s.alphswitchflag Then
				s.alpha :-.02
				If s.alpha < 0 Then
					steamlist.remove(s:steam)
				EndIf
			Else
				s.alpha :+.08
				If s.alpha > 1 Then
					s.alpha = 1
					s.alphswitchflag = True
				EndIf
			EndIf
		Next
		SetAlpha 1
		SetScale 1,1
		SetBlend alphablend
	End Function
End Type

Type enemy
	Global enemylist:TList = New TList
	Field x:Float
	Field y:Float
	Field plist:TList
	Field nump:Int
	Field althitflag:Int
	Field switchflag:Int
	Field switchcount:Int
	
	Function clear()
		For Local e:enemy = EachIn enemylist

			enemylist.remove(e:enemy)
		Next
	End Function
	
	Function Create:enemy(x:Int,y:Int,radius:Int,nump:Int)
		Local e:enemy = New enemy
		e.x = x
		e.y = y
		e.nump = nump
		e.plist:TList = New TList
		For Local i:Int = 1 To nump
			Local v:verlet = makelava(e.x+Rnd(-radius,radius),e.y+Rnd(-radius,radius))
			e.plist.addlast(v:verlet)
		Next
		enemylist.addlast(e:enemy)
	End Function
	
	Function update()
		
		Local totx:Float
		Local toty:Float
		Local totcnt:Int
		For Local e:enemy = EachIn enemylist
			e.althitflag = Not e.althitflag
			totx = 0
			toty = 0
			totcnt = 0
			Local v:verlet
			For v:verlet = EachIn e.plist
				totcnt:+1
				Local dx:Float = e.x-v.x
				Local dy:Float = e.y-v.y
				Local dist:Float = Sqr(dx*dx + dy*dy)
				dx :/dist *8
				dy :/dist *8
				v.addvelocity(dx,dy)
				totx:+v.x
				toty:+v.Y
				If v.flid = ID_rock Then e.plist.remove(v:verlet)
				If v.y > levely + levelheight+8 Then
					e.plist.remove(v:Verlet)
					v.remove()
				EndIf
				
			Next
			
			totx :/totcnt
			toty :/totcnt
			
			e.x = totx
			e.y = toty
			
			draweye(e.x-20,e.y-20)
			draweye(e.x+20,e.y-20)
			
			Local tmpx:Float = plx
			Local tmpy:Float = ply
			
			If e.x > tmpx Then e.x :-20
			If e.x < tmpy Then e.x :+20
			
			e.switchcount:+1
			If e.switchcount > 50 Then
				e.switchcount = 0
				e.switchflag = Not e.switchflag
			EndIf
			
			If e.switchflag And enemysetshoot Then
				Local smalldist:Float = 100000
				Local dxflg:Float
				Local dyflg:Float
				Local vflg:verlet
				Local tmpx2:Float = tmpx-e.x
				Local tmpy2:Float = tmpy-e.y
				If Sqr(tmpx2*tmpx2 + tmpy2*tmpy2) < 500 Then
					For Local vv:verlet = EachIn e.plist
						Local dx:Float = vv.x-tmpx
						Local dy:Float = vv.y-tmpy
						Local num:Float = Sqr(dx*dx + dy*dy)
						If num < smalldist Then
							smalldist = num
							vflg:verlet = vv:verlet
							dxflg = dx
							dyflg = dy
						EndIf
						
					Next
					smalldist = (smalldist)
					If smalldist > 0 Then
						If vflg <> Null Then
							dxflg = dxflg / smalldist
							dyflg = dyflg / smalldist
							dxflg = dxflg * 8
							dyflg = dyflg * 8
							vflg.addvelocity(-dxflg,-dyflg)
							e.plist.remove(vflg:verlet)
						EndIf
					EndIf
				EndIf
			EndIf
			If totcnt < 20 Then
				enemylist.remove(e:enemy)
				For Local i:Int = 0 To 80
					steam.Create(e.x+Rnd(-60,60),e.y+Rnd(-10,-5),Rnd(-.3,.3),Rnd(-2,-.5),Rnd(0,.4))
				Next
				
			EndIf
		Next
		
	End Function
	
	Function clearall()
		For Local e:enemy = EachIn enemylist
			enemylist.remove(e:enemy)
		Next
	End Function
End Type

Function draweye(x:Int,y:Int)
	
	SetColor 255,255,255
	DrawOval (x-10)+physicsoffsetx,(y-10)+physicsoffsety,20,20
	
	SetColor 0,0,0
	Local dx# = (plx)-x
	Local dy# = (ply)-y
	Local dist# = Sqr(dx*dx + dy*dy)
	dx = dx / dist
	dy = dy / dist
	dx = dx * 6
	dy = dy * 6
	DrawOval (x+physicsoffsetx)+dx-5,(y+physicsoffsety)+dy-5,10,10
	SetColor 255,255,255
End Function

Function makelava:verlet(x:Int,y:Int)
	Local v:verlet = verlet.Create(x,y,7,1,ID_Fluid,1,0,0)
	v.setfluidproperties(True,5.4,4,.03,.2,ID_Lava)
	v.image = water
	v.color(255,80,0)
	v.alpha(.5)
	v.blendmode = lightblend
	Return v:verlet
End Function

Function makewater:verlet(x:Int,y:Int)
	Local v:verlet = verlet.Create(x,y,7,.4,ID_Fluid,1,0,0)
	v.setfluidproperties(True,7.7,5,.01,.1,ID_Water)
	v.image = water
	v.color(30,40,255)
	v.alpha(.7)
	v.blendmode = lightblend
	Return v:verlet
End Function


Type coin
	Global coinlist:TList = New TList
	
	Field x:Int
	Field y:Int
	Field sndflg:Int
	
	Function Create:coin(x:Int,y:Int)
		Local c:coin = New coin
		c.x = x
		c.y = y
		coinlist.addlast(c:coin)
		Return c:coin
	End Function
	
	Function update()
		coin.draw
		
		For Local c:coin = EachIn coinlist
			Local dx:Float = plx-c.x
			Local dy:Float = ply-c.y
			Local dist:Int = dx*dx + dy*dy
			If dist < 10000 Then
				steam.Create(c.x,c.y,Rnd(-.3,.3),Rnd(-2,-.5),Rnd(0,.2),Rnd(100,255),Rnd(100,255),Rnd(100))
				dist = Sqr(dist)
				If dist > 0 Then
										
					If dist < 20 Then
						PlaySound(collect)
						plpoints :+5
						coinlist.remove(c:coin)
					Else
						Local str:Float = (100-dist)/100.0
						dx = dx / dist
						dy = dy / dist
						dx = dx  * str * 8
						dy = dy  * str * 8
						c.x :+dx
						c.y :+dy
					EndIf
				EndIf
			EndIf
		Next
	End Function
	
	Function draw()
		For Local c:coin = EachIn coinlist
			SetColor 255,255,0
			SetAlpha .7
			DrawOval c.x+physicsoffsetx-3,c.y+physicsoffsety-3,6,6
			SetBlend lightblend
			DrawImage water,c.x+physicsoffsetx,c.y+physicsoffsety
			SetBlend alphablend
			SetAlpha 1
			SetColor 255,255,255
		Next
	End Function
	
	Function clear()
		For Local c:coin = EachIn coinlist
			coinlist.remove(c:coin)
		Next
	End Function
End Type

Rem
Function DrawTexturedPoly( image:TImage,xyuv#[],frame:Int=0, vertex:Int = -1)
	Local handle_x#,  handle_y#
	GetHandle handle_x#,  handle_y#
	Local origin_x#,  origin_y#
	GetOrigin origin_x#,  origin_y#	
	
	Local D3DDriver:TD3D7Max2DDriver = TD3D7Max2DDriver(_max2dDriver)
	
	Assert Image, "Image not found"
	
	If D3DDriver Then 
		DrawTexturedPolyD3D ..
			D3DDriver,..
			 TD3D7ImageFrame(image.Frame(frame)), ..
			 xyuv, handle_x, handle_y, origin_x,origin_y, vertex*4
		Return
	End If
	Local  OGLDriver:TGLMax2DDriver = TGLMax2DDriver(_max2dDriver)
	If OGLDriver Then
			DrawTexturedPolyOGL ..
				OGLDriver,..
				 TGLImageFrame(image.Frame(frame)), ..
				 xyuv, handle_x, handle_y, origin_x,origin_y,  vertex*4
		Return
	End If
End Function


Function DrawTexturedPolyD3D( Driver:TD3D7Max2DDriver,  Frame:TD3D7ImageFrame,xyuv#[],handlex#,handley#,tx#,ty# , vertex:Int)
	
	If xyuv.length<6 Return
	Local segs:Int = xyuv.length/4
	Local len_:Int = Len(xyuv)
	
	If vertex > - 1 Then
		segs = vertex / 4
		len_ = vertex
	End If
	Local uv#[] = New Float[segs*6] ' 6
	

	Local c:Int Ptr=Int Ptr(Float Ptr(uv))
	
	Local ii:Int = 0
	For Local i:Int=0 Until len_ Step 4
		Local x# =  xyuv[i+0]+handlex
		Local y# =  xyuv[i+1]+handley
		uv[ii+0] =  x*Driver.ix+y*Driver.iy+tx
		uv[ii+1] =  x*Driver.jx+y*Driver.jy+ty 
		uv[ii+2] =  0  ' *********** THIS IS THE Z-COORDINATE
		c[ii+3] = Driver.DrawColor
		uv[ii+4] =  xyuv[i+2]
		uv[ii+5] =  xyuv[i+3]
		ii:+6
	Next
	Driver.SetActiveFrame Frame
	Driver.device.DrawPrimitive(D3DPT_TRIANGLEFAN,D3DFVF_XYZ| D3DFVF_DIFFUSE | D3DFVF_TEX1,uv,segs,0)
End Function

Function DrawTexturedPolyOGL (Driver:TGLMax2DDriver, Frame:TGLImageFrame, xy#[],handle_x#,handle_y#,origin_x#,origin_y#, vertex:Int) 
	Private
	Global TmpImage:TImage
	Public
	
	If xy.length<6 Return
	
	Local rot#  = GetRotation()
	Local tform_scale_x#, tform_scale_y#
	GetScale tform_scale_x, tform_scale_y
	
	Local s#=Sin(rot)
	Local c#=Cos(rot)
	Local ix#= c*tform_scale_x
	Local iy#=-s*tform_scale_y
	Local jx#= s*tform_scale_x
	Local jy#= c*tform_scale_y
	
	glBindTexture GL_TEXTURE_2D, Frame.name
	glEnable GL_TEXTURE_2D
	
	glBegin GL_POLYGON
	For Local i:Int =0 Until Len xy Step 4
		If vertex > -1 And i >= vertex Then Exit
		Local x#=xy[i+0]+handle_x
		Local y#=xy[i+1]+handle_y
		Local u#=xy[i+2]
		Local v#=xy[i+3]
		glTexCoord2f u,v
		glVertex2f x*ix+y*iy+origin_x,x*jx+y*jy+origin_y
	Next
	glEnd
	If Not tmpImage Then tmpImage = CreateImage(1,1)
	DrawImage tmpImage, -100, - 100 ' Chtob zbit' flag texturi
End Function
EndRem

Function renderhud()
	SetColor 255,255,255
	SetAlpha .5
	
	DrawRect 30,740,302,20	'water thing
	DrawRect 360,740,202,20	'heat bar
	DrawRect 590,740,302,20	'health bar
	
	SetColor 0,10,255
	
	DrawRect 31,741,300*(plwater/pltanksize),18
	
	SetColor 255,10,10
	
	DrawRect 361,741,200*(plheat/10),18
	
	Local r:Int
	Local g:Int
	
	If plhealth < 50 Then
		r = 255
	Else
		r = 255*((-plhealth+100)/50)
	EndIf
	
	If plhealth > 50 Then
		g = 255
	Else
		g = 255*((plhealth)/50)
	EndIf
	SetColor r,g,0
	
	If plheat > 1 Then plhealth = plhealth - (plheat-1)/2
	If plhealth <= 0 Then
		plhealth = 0
		plheat = plheat + .2
	EndIf
	If plheat > 10 Then
		pldie = True
		plheat = 10
	EndIf
	
	
	If plhealth > 100 Then plhealth = 100
	DrawRect 591,741,300*(plhealth/100.0),18
	
	'SetColor 
	SetColor 255,255,255
	SetAlpha 1
	DrawText "Water Tank Level",30,724 
	DrawText "Ship Temperature",360,724
	DrawText "Shields",590,724

End Function
