Global maxverlsiz:Int			'maximum verlet siz * 2
Global Friction:Float = .998		'Friction should be close to 1 unless you want very slow movement

Global Gravityx:Float = 0			'Gravity x		gravity vector
Global Gravityy:Float = .07			'Gravity y

Global physicsoffsetx:Float			'Offset x
Global physicsoffsety:Float			'offset y
Global physicsscalex:Float = 1			'scaling offset x
Global physicsscaley:Float = 1			'scaling offset y
Global physicsoriginx:Float = GraphicsWidth()/2
Global physicsoriginy:Float = GraphicsHeight()/2
Global VerletDamper:Float = 1	'the lower this number is, the more stable stacking will be but also the lower the precision will be.  It basically alows for 'soft' collisions between verlets

Global physicsUpperBound:Int = 0	'Upper physics bound
Global physicsLowerBound:Int = 0	'lower physics bound
Global physicsLeftBound:Int = 0	'left physics bound
Global physicsRightBound:Int = 0	'right physics bound


Function InitVerletMax()
		
	Physicsupperbound = 0
	physicslowerbound = GraphicsHeight()
	physicsleftbound = 0
	physicsrightbound = GraphicsWidth()
	
	physicsoffsetx = 0
	physicsoffsety = 0
	
	physicsscalex = 1
	physicsscaley = 1
	
	physicsoriginx = GraphicsWidth()/2
	physicsoriginy = GraphicsHeight()/2
	
End Function

Function Setphysicsbounds(x:Int,y:Int,width:Int,height:Int)
	physicsupperbound = y
	physicsleftbound = x
	physicslowerbound = y+height
	physicsrightbound = x+width
End Function


Function SetPhysicsScale(xscale:Float,yscale:Float)
	physicsscalex = xscale
	physicsscaley = yscale
End Function

Function MovePhysicsCam(x:Float,y:Float)
	physicsoffsetx :+ x
	physicsoffsety :+ y
End Function

Function PositionPhysicsCam(x:Float,y:Float)
	physicsoffsetx = x
	physicsoffsety = y
End Function

Function UpdatePhysics(cnt:Int = 1)
	For Local i:Int = 1 To cnt
		Local t124:Int = MilliSecs()
		Verlet.update
		Local t125:Int = MilliSecs()
		UpdateConstraints()
		Local t123:Int = MilliSecs()
		UpdateVerletPolysegCollisions()
		DoCCollisions()
		flconstraint.update()
		Local t126:Int = MilliSecs()
		If KeyDown(key_space) Then				'debuging
		'	Print "UpdateLoop      "+(t125-t124)
		'	Print "ConstraintLoop  "+(t123-t125)
		'	Print "PolysegLoop     "+(t126-t123)
		EndIf
	Next
End Function