'this is used for the constraint-verlet collisions to store their positions and reposition them after the loop ends
Type ccollide
	Global collidearray:ccollide[100]
	Global collidecount:Int
	Field c:constraint
	Field v:verlet
	Field cv1x#
	Field cv1y#
	Field cv2x#
	Field cv2y#
	Field vx#
	Field vy#
	Field ocv1x#
	Field ocv1y#
	Field ocv2x#
	Field ocv2y#
	Field ovx#
	Field ovy#

	
	Function Create:ccollide(c:constraint,v:verlet,x1#,y1#,x2#,y2#,x3#,y3#)
		Local cc:ccollide = New ccollide
		
		cc.c = c
		cc.v = v
		
		cc.ocv1x = c.v1.x
		cc.ocv1y = c.v1.y
		cc.ocv2x = c.v2.x
		cc.ocv2y = c.v2.y
		cc.ovx = v.x
		cc.ovy = v.y
		
		cc.cv1x = x1
		cc.cv1y = y1
		cc.cv2x = x2
		cc.cv2y = y2
		cc.vx = x3
		cc.vy = y3
		
		collidearray:ccollide[collidecount] = cc:ccollide
		collidecount:+1
		If collidecount + 2 >= collidearray.length Then collidearray = collidearray[..(collidearray.length + 50)]
		
		Return cc:ccollide
		
	End Function
	
	Function clear()
		If collidecount > 100 Then collidearray = collidearray[..10]
		collidecount = 0
	End Function
	
	Function update()
		Local i:Int
		Local c:ccollide
		For i = 0 To collidecount - 1
			c:ccollide = collidearray:ccollide[i]
			c.c.v1.ox = c.ocv1x
			c.c.v1.x = c.cv1x
			c.c.v1.oy = c.ocv1y
			c.c.v1.y = c.cv1y
			c.c.v2.ox = c.ocv2x
			c.c.v2.x = c.cv2x
			c.c.v2.oy = c.ocv2y
			c.c.v2.y = c.cv2y
			c.v.ox = c.ovx
			c.v.x = c.vx
			c.v.oy = c.ovy
			c.v.y = c.vy
		Next
		ccollide.clear
	End Function
End Type